Bug 1738182 - rdiff-backup depends on Python 2
Summary: rdiff-backup depends on Python 2
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: rdiff-backup
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kevin Fenzi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F31_PY2REMOVAL
TreeView+ depends on / blocked
 
Reported: 2019-08-06 13:23 UTC by Lumír Balhar
Modified: 2020-05-09 09:09 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-09 09:09:59 UTC
Type: Bug


Attachments (Terms of Use)

Description Lumír Balhar 2019-08-06 13:23:34 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for rdiff-backup's future. Specifically:


- What is the reason for the Python2 dependency? (Is it software written in Python, or does it just provide Python bindings, or use Python in the build system or test runner?) 

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to rdiff-backup.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Ben Cotton 2019-08-13 17:00:34 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 2 Ben Cotton 2019-08-13 17:39:38 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 3 Kevin Fenzi 2019-08-14 22:51:39 UTC
Upstream recently became revitalised and has a python3 port. 

https://github.com/rdiff-backup/rdiff-backup

Hopefully they will have a python3 usable version very soon.

Comment 4 Petr Viktorin 2019-08-15 10:17:35 UTC
That's great news!
We're planning to remove Python 2 mid-November. If there's a chance of not being ready by then, let us know.

Comment 5 Frank Crawford 2019-11-01 12:07:17 UTC
The Python3 version of rdiff-backup is nearing release, targeted to be done before the end of 2019, and we have already built test versions of the new release.

We will submit an exemption request to FESCo to stop any removal.

Comment 6 Petr Viktorin 2019-11-01 12:10:13 UTC
If the new release works, consider putting it in Rawhide, and help find any remaining bugs in real-world usage.
Would that be too dangerous?

Comment 7 Frank Crawford 2019-11-01 12:18:41 UTC
That is the intention shortly.  I'm just waiting for upstream to finalise some of their current changes.

Comment 8 Frank Crawford 2019-11-01 12:19:34 UTC
Submitted FESCo request https://pagure.io/fesco/issue/2262

Comment 9 dan.cermak 2019-11-10 22:32:09 UTC
Can you please update this bug once rdiff-backup moves to Python 3? I'd then remove the python2 subpackage of pyxattr.

Comment 10 Kevin Fenzi 2019-11-10 23:25:00 UTC
Sure, although Frank is doing that work at the moment. We will be sure to let you know when it's moved over...

Comment 11 Frank Crawford 2019-11-24 03:49:54 UTC
For anyone wanting to test it, the current rdiff-backup python3 beta has been pushed to rawhide as rdiff-backup-1.4.0b0-1.fc32.

You should note that while it should be compatible with the previous rdiff-backup archives, it is note compatible with the previous (1.2.8) program, so you will need it on all hosts you are running in client/server mode.

Comment 12 Eric Lavarde 2020-05-09 09:04:05 UTC
I guess, we can close this bug with the release of Fedora 32:

```
$ sudo dnf info rdiff-backup --showduplicates
Last metadata expiration check: 2:01:29 ago on Sat 09 May 2020 09:00:56.
Available Packages
Name         : rdiff-backup
Version      : 2.0.0
Release      : 1.fc32
Architecture : x86_64
Size         : 350 k
Source       : rdiff-backup-2.0.0-1.fc32.src.rpm
Repository   : fedora
Summary      : Convenient and transparent local/remote incremental mirror/backup
```

Well done, Frank! EricZolf.

Comment 13 Frank Crawford 2020-05-09 09:09:59 UTC
(In reply to Eric Lavarde from comment #12)
> I guess, we can close this bug with the release of Fedora 32:

You are right, we can.  Thanks Eric.


Note You need to log in before you can comment on or make changes to this bug.